import java.applet.Applet;
import java.awt.BasicStroke;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.Line2D;

/**
   This applet draws a chart of the average monthly
   temperatures in Phoenix, AZ.
*/
public class ChartApplet extends Applet
{  
   public void paint(Graphics g)
   {  
      Graphics2D g2 = (Graphics2D)g;
  
      double xscale = (getWidth() - 1.0) / (XMAX - XMIN);
      double yscale = (getHeight() - 1.0) / (YMIN - YMAX);
      g2.scale(xscale, yscale);
      g2.translate(-XMIN, -YMAX);
      g2.setStroke(new BasicStroke(0));

      month = 1;

      drawBar(g2, JAN_TEMP);
      drawBar(g2, FEB_TEMP);
      drawBar(g2, MAR_TEMP);
      drawBar(g2, APR_TEMP);
      drawBar(g2, MAY_TEMP);
      drawBar(g2, JUN_TEMP);
      drawBar(g2, JUL_TEMP);
      drawBar(g2, AUG_TEMP);
      drawBar(g2, SEP_TEMP);
      drawBar(g2, OCT_TEMP);
      drawBar(g2, NOV_TEMP);
      drawBar(g2, DEC_TEMP);
   }

   /**
      Draws a bar for the current month and increments
      the month.
      @param g2 the graphics context
      @param temperature the temperature for the month
   */
   public void drawBar(Graphics2D g2, int temperature)
   {  
      Line2D.Double bar
         = new Line2D.Double(month, 0, month, temperature);

      g2.draw(bar);
      
      month++;
   }

   private static final int JAN_TEMP = 11;
   private static final int FEB_TEMP = 13;
   private static final int MAR_TEMP = 16;
   private static final int APR_TEMP = 20;
   private static final int MAY_TEMP = 25;      
   private static final int JUN_TEMP = 31;
   private static final int JUL_TEMP = 33;
   private static final int AUG_TEMP = 32;
   private static final int SEP_TEMP = 29;
   private static final int OCT_TEMP = 23;
   private static final int NOV_TEMP = 16;
   private static final int DEC_TEMP = 12;

   private static final double XMIN = 1;
   private static final double XMAX = 12;
   private static final double YMIN = 0;
   private static final double YMAX = 40;

   private int month;
}

