import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Line2D;
import javax.swing.JOptionPane;

/**
   An applet that computes and draws the intersection points
   of a circle and a line.
*/
public class IntersectionApplet extends Applet
{  
   public IntersectionApplet()
   {  
      String input
         = JOptionPane.showInputDialog("x:");
      x = Integer.parseInt(input);
   }
   
   public void paint(Graphics g)
   {  
      Graphics2D g2 = (Graphics2D)g;

      double r = 100; // the radius of the circle
      
      // draw the circle

      Ellipse2D.Double circle 
         = new Ellipse2D.Double(0, 0, 2 * RADIUS, 2 * RADIUS);
      g2.draw(circle);
      
      // draw the vertical line

      Line2D.Double line
         = new Line2D.Double(x, 0, x, 2 * RADIUS);
      g2.draw(line);
      
      // compute the intersection points
      
      double a = RADIUS;
      double b = RADIUS;

      double root = Math.sqrt(RADIUS * RADIUS - (x - a) * (x - a));
      double y1 = b + root;
      double y2 = b - root;
      
      // draw the intersection points

      LabeledPoint p1 = new LabeledPoint(x, y1);
      LabeledPoint p2 = new LabeledPoint(x, y2);
      
      p1.draw(g2);
      p2.draw(g2);
   }

   private static final double RADIUS = 100;
   private double x;
}
