public class PowerTable
{
   public PowerTable(int aRowCount, int aColumnCount)
   {
      rows = aRowCount;
      columns = aColumnCount;
      columnWidth = (int)Math.ceil(columns * Math.log(rows) / Math.log(10)) + 1;
   }

   public void print()
   {
      for (int x = 1; x <= rows; x++)
      {  
         // print table row

         for (int y = 1; y <= columns; y++)
         {  
            int power = (int)Math.pow(x, y);
            printInColumn(power);
         }
         System.out.println();
      }

   }

   public void printInColumn(int value)
   {
      int valueWidth = ("" + value).length();
      for (int i = valueWidth + 1; i <= columnWidth; i++)
         System.out.print(" ");
      System.out.print(value);
   }

   private int rows;
   private int columns;
   private int columnWidth;
}
