import java.util.Random;

/**
   This program verifies the computation of square root values
   by checking a mathematical property of square roots.
*/
public class RootApproximatorTest6
{  
   public static void main(String[] args)
   {  
      final double SAMPLES = 100;
      int passcount = 0;
      int failcount = 0;
      Random generator = new Random();
      for (int i = 1; i <= SAMPLES; i++)
      {  
         // generate random test value

         double x = 1.0E6 * generator.nextDouble();
         RootApproximator r = new RootApproximator(x);
         double y = r.getRoot();
         System.out.println("square root of " + x
            + " = " + y);

         // check that test value fulfills square property

         if (Numeric.approxEqual(y * y, x))
         {
            System.out.println("Test passed.");
            passcount++;
         }
         else
         {
            System.out.println("Test failed.");
            failcount++;
         }
      }
      System.out.println("Pass: " + passcount);
      System.out.println("Fail: " + failcount);
   }
}
