import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JOptionPane;
import javax.swing.Timer;

/**
   This program uses a timer to add interest to a bank 
   account once per second.
*/
public class TimerTest
{
   public static void main(String[] args)
   {
      final BankAccount account = new BankAccount(1000);

      class InterestAdder implements ActionListener
      {
         public void actionPerformed(ActionEvent event)
         {
            double interest = account.getBalance() * RATE / 100;
            account.deposit(interest);
            System.out.println("Balance = " 
               + account.getBalance());
         }
      }

      InterestAdder listener = new InterestAdder();

      final int DELAY = 1000; // milliseconds between timer ticks
      Timer t = new Timer(DELAY, listener);
      t.start();

      JOptionPane.showMessageDialog(null, "Quit?");
      System.exit(0);
   }

   private static final double RATE = 5;
}
