import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

/**
   This program shows a frame with a text area that displays
   the growth of an investment. A second frame holds a text
   field to specify the interest rate.
*/
public class TextAreaTest
{  
   public static void main(String[] args)
   {  
      // the application adds interest to this bank account
      final BankAccount account = new BankAccount(INITIAL_BALANCE);
      // the text area for displaying the results
      final JTextArea textArea = new JTextArea(10, 30);
      textArea.setEditable(false);
      JScrollPane scrollPane = new JScrollPane(textArea);

      // construct the frame for displaying the text area
      JFrame frame = new JFrame();
      frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      frame.setContentPane(scrollPane);
      frame.pack();
      frame.show();

      // the label and text field for entering the interest rate
      JLabel rateLabel = new JLabel("Interest Rate: ");

      final JTextField rateField = new JTextField(10);
      rateField.setText("" + DEFAULT_RATE);

      // the button to trigger the calculation
      JButton calculateButton = new JButton("Add Interest");
      
      class CalculateListener implements ActionListener
      {
         public void actionPerformed(ActionEvent event)
         {
            double rate = Double.parseDouble(
               rateField.getText());
            double interest = account.getBalance() 
               * rate / 100;
            account.deposit(interest);
            textArea.append(account.getBalance() + "\n");
         }            
      }

      ActionListener listener = new CalculateListener();
      calculateButton.addActionListener(listener);

      // the control panel that holds the input components
      JPanel controlPanel = new JPanel();
      controlPanel.add(rateLabel);
      controlPanel.add(rateField);
      controlPanel.add(calculateButton);

      // the frame to hold the control panel
      JFrame controlFrame = new JFrame();
      controlFrame.setContentPane(controlPanel);
      controlFrame.pack();
      controlFrame.show();
   }

   private static final double DEFAULT_RATE = 10;
   private static final double INITIAL_BALANCE = 1000;
}
