import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;

/**
   This applet lets the user move a rectangle by clicking
   the mouse.
*/
public class MouseApplet extends Applet
{  
   public MouseApplet()
   {  
      // the rectangle that the paint method draws
      box = new Rectangle(BOX_X, BOX_Y, 
         BOX_WIDTH, BOX_HEIGHT);
         
      // add mouse press listener         

      class MousePressListener implements MouseListener
      {  
         public void mousePressed(MouseEvent event)
         {  
            int x = event.getX();
            int y = event.getY();
            box.setLocation(x, y);
            repaint();
         }

         // do-nothing methods
         public void mouseReleased(MouseEvent event) {}
         public void mouseClicked(MouseEvent event) {}
         public void mouseEntered(MouseEvent event) {}
         public void mouseExited(MouseEvent event) {}
      }
         
      MouseListener listener = new MousePressListener();
      addMouseListener(listener);
   }

   public void paint(Graphics g)
   {  
      Graphics2D g2 = (Graphics2D)g;
      g2.draw(box);
   }

   private Rectangle box;
   private static final int BOX_X = 100;
   private static final int BOX_Y = 100;
   private static final int BOX_WIDTH = 20;
   private static final int BOX_HEIGHT = 30;
} 
