import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
   This frame contains a panel that displays a rectangle
   and a panel of text fields to specify the rectangle position.
*/
public class RectangleFrame extends JFrame
{
   /**
      Constructs the frame.
   */
   public RectangleFrame()
   {
      // the panel that draws the rectangle
      rectPanel = new RectanglePanel();

      // add panel to content Pane
      getContentPane().add(rectPanel, BorderLayout.CENTER);

      createControlPanel();

      pack();
   }

   /**
      Creates the control panel with the text fields
      at the bottom of the frame.
   */
   private void createControlPanel()
   {
      // the text fields for entering the x- and y-coordinates
      final JTextField xField = new JTextField(5);
      final JTextField yField = new JTextField(5);;

      // the button to move the rectangle
      JButton moveButton = new JButton("Move");

      class MoveButtonListener implements ActionListener
      {
         public void actionPerformed(ActionEvent event)
         {
            int x = Integer.parseInt(xField.getText());
            int y = Integer.parseInt(yField.getText());
            rectPanel.setLocation(x, y);
         }
      };

      ActionListener listener = new MoveButtonListener();
      moveButton.addActionListener(listener);

      // the labels for labeling the text fields
      JLabel xLabel = new JLabel("x = ");
      JLabel yLabel = new JLabel("y = ");

      // the panel for holding the user interface components
      JPanel controlPanel = new JPanel();

      controlPanel.add(xLabel);
      controlPanel.add(xField);
      controlPanel.add(yLabel);
      controlPanel.add(yField);
      controlPanel.add(moveButton);

      getContentPane().add(controlPanel, BorderLayout.SOUTH);
   }

   private RectanglePanel rectPanel;
}





