import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import javax.swing.JPanel;

/**
   This panel displays a rectangle.
*/
public class RectanglePanel extends JPanel
{  
   /**
      Constructs a rectangle panel with the rectangle at a 
      default location.
   */
   public RectanglePanel()
   {  
      setPreferredSize(new Dimension(PANEL_WIDTH, PANEL_HEIGHT));
      // the rectangle that the paint method draws
      box = new Rectangle(BOX_X, BOX_Y, 
         BOX_WIDTH, BOX_HEIGHT);
   }

   /**
      Sets the location of the rectangle and repaints the panel.
      @param x the x-coordinate of the top left corner of the rectangle
      @param y the y-coordinate of the top left corner of the rectangle
   */
   public void setLocation(int x, int y)
   {
      box.setLocation(x, y);
      repaint();
   }

   public void paintComponent(Graphics g)
   {  
      super.paintComponent(g);
      Graphics2D g2 = (Graphics2D)g;
      g2.draw(box);
   }

   private Rectangle box;
   private static final int BOX_X = 100;
   private static final int BOX_Y = 100;
   private static final int BOX_WIDTH = 20;
   private static final int BOX_HEIGHT = 30;

   private static final int PANEL_WIDTH = 300;
   private static final int PANEL_HEIGHT = 300;
}
