import javax.swing.JOptionPane;
import java.io.IOException;

/**
   This program prompts the user to enter a file name
   with coin values. A purse object is filled with
   the coins specified in the file. In case of an exception,
   the user can choose another file.
*/
public class PurseTest
{
   public static void main(String[] args)
   {
      boolean done = false;
      String filename 
         = JOptionPane.showInputDialog("Enter file name");

      while (!done)
      {
         try
         {
            Purse myPurse = new Purse();
            myPurse.readFile(filename);
            System.out.println("total=" + myPurse.getTotal());
            done = true;
         }   
         catch (IOException exception)        
         {
            System.out.println("Input/output error " + exception);  
         }   
         catch (NumberFormatException exception)
         {         
            exception.printStackTrace();
         }

         if (!done)
         {
            filename = JOptionPane.showInputDialog(
               "Try another file:");
            if (filename == null) done = true;
         }
      }
      System.exit(0);
   }
}
