import java.io.IOException;
import java.io.RandomAccessFile;
import javax.swing.JOptionPane;

/**
   This program tests random access. You can access existing
   accounts and add interest, or create a new accounts. The
   accounts are saved in a random access file.
*/
public class BankDataTest
{  
   public static void main(String[] args)
      throws IOException
   {  
      BankData data = new BankData();
      try
      {  
         data.open("bank.dat");

         boolean done = false;
         while (!done)
         {  
            String input = JOptionPane.showInputDialog(
               "Account number or " + data.size() 
               + " for new account");
            if (input == null) done = true;
            else
            {
               int pos = Integer.parseInt(input);

               if (0 <= pos && pos < data.size()) // add interest
               {  
                  SavingsAccount account = data.read(pos);
                  System.out.println("balance=" 
                     + account.getBalance() + ",interest rate=" 
                     + account.getInterestRate());
                  account.addInterest();
                  data.write(pos, account);
               }
               else // add account
               {  
                  input = JOptionPane.showInputDialog("Balance");
                  double balance = Double.parseDouble(input);
                  input = JOptionPane.showInputDialog("Interest Rate");
                  double interestRate = Double.parseDouble(input);
                  SavingsAccount account 
                     = new SavingsAccount(interestRate);
                  account.deposit(balance);
                  data.write(data.size(), account);
               }
            }
         }
      }
      finally
      {
         data.close();
         System.exit(0);
      }
   }
}















