import java.io.File;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import javax.swing.JOptionPane;

/**
   This program tests serialization of a Purse object.
   If a file with serialized purse data exists, then it is
   loaded. Otherwise the program starts with a new purse.
   More coins are added to the purse. Then the purse data
   are saved.
*/
public class PurseTest
{
   public static void main(String[] args)
      throws IOException, ClassNotFoundException
   {     
      Purse myPurse;
      
      File f = new File("purse.dat");
      if (f.exists())
      {
         ObjectInputStream in = new ObjectInputStream
            (new FileInputStream(f));
         myPurse = (Purse)in.readObject();
         in.close();
      }
      else myPurse = new Purse();

      // add coins to the purse
      myPurse.add(new Coin(NICKEL_VALUE, "nickel"));
      myPurse.add(new Coin(DIME_VALUE, "dime"));
      myPurse.add(new Coin(QUARTER_VALUE, "quarter"));
      
      double totalValue = myPurse.getTotal();
      System.out.println("The total is " + totalValue);

      ObjectOutputStream out = new ObjectOutputStream
         (new FileOutputStream(f));
      out.writeObject(myPurse);
      out.close();
   }

   private static double NICKEL_VALUE = 0.05;
   private static double DIME_VALUE = 0.1;
   private static double QUARTER_VALUE = 0.25;
}
