import javax.swing.JOptionPane;

/**
   This program computes Fibonacci numbers using an iterative
   method.
*/ 
public class FibLoop
{  
   public static void main(String[] args)
   {  
      String input = JOptionPane.showInputDialog("Enter n: ");
      int n = Integer.parseInt(input);

      for (int i = 1; i <= n; i++)
      {
         double f = fib(i);
         System.out.println("fib(" + i + ") = " + f);
      }
      System.exit(0);
   }

   /**
      Computes a Fibonacci number.
      @param n an integer
      @return the nth Fibonacci number
   */
   public static double fib(int n)
   {  
      if (n <= 2) return 1;
      double fold = 1;
      double fold2 = 1;
      double fnew = 1;
      for (int i = 3; i <= n; i++)
      {  
         fnew = fold + fold2;
         fold2 = fold;
         fold = fnew;
      }
      return fnew;
   }
}
