/**
   This class generates permutations of a word.
*/
class PermutationGenerator
{
   /**
      Constructs a permutation generator.
      @param aWord the word to permute
   */
   public PermutationGenerator(String aWord)
   {
      word = aWord;
      current = 0;
      if (s.length() > 1)
         tailGenerator = new PermutationGenerator(word.substring(1));
   }

   /**
      Computes the next permutation of the word.
      @return the next permutation
   */
   public String nextPermutation()
   {
      if (word.length() == 1) 
      {
         current++;
         return word;
      }

      String r = word.charAt(current) + tailGenerator.nextPermutation();

      if (!tailGenerator.hasMorePermutations())
      {
         current++;
         if (current < word.length())
         {
            String tailString = word.substring(0, current)
               + word.substring(current + 1);
            tailGenerator = new PermutationGenerator(tailString);
         }
      }

      return r;
   }

   /**
      Tests whether there are more permutations.
      @return true if more permutations are available
   */
   public boolean hasMorePermutations()
   {
      return current < word.length();
   }

   private String word;
   private int current;
   private PermutationGenerator tailGenerator;
}
