import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

/**
   A purse holds a collection of coins.
*/
public class Purse
{
   /**
      Constructs an empty purse.
   */
   public Purse()
   {
      coins = new ArrayList();
   }

   /**
      Add a coin to the purse.
      @param aCoin the coin to add
   */
   public void add(Coin aCoin)
   {
      coins.add(aCoin);
   }

   /**
      Returns a string describing the purse contents,
      sorted by coin value.
      @return the string describing the purse contents
   */
   public String toString()
   {
      // sort the coins first
      class CoinComparator implements Comparator
      {
         public int compare(Object firstObject, Object secondObject)
         {
            Coin first = (Coin)firstObject;
            Coin second = (Coin)secondObject;
            if (first.getValue() < second.getValue()) return -1;
            if (first.getValue() == second.getValue()) return 0;
            return 1;
         }       
      }

      Comparator comp = new CoinComparator();
      Collections.sort(coins, comp);

      String r = "Purse[coins=";
      for (int i = 0; i < coins.size(); i++)
      {
         if (i > 0) r = r + ",";
         r = r + coins.get(i);
      }
      return r + "]";
   }

   private ArrayList coins;
}

