import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.sql.SQLException;

/**
   A bank account has a balance that can be changed by 
   deposits and withdrawals.
*/
public class BankAccount
{  
   /**
      Constructs a bank account with a given balance.
      @param anAccountNumber the account number
   */
   public BankAccount(int anAccountNumber)
   {  
      accountNumber = anAccountNumber;
   }

   /**
      Deposits money into a bank account.
      @param accountNumber the account number
      @param amount the amount to deposit
   */
   public void deposit(double amount)
      throws SQLException
   {
      Connection conn = SimpleDataSource.getConnection();
      Statement stat = conn.createStatement();
      stat.execute("UPDATE Account"
         + " SET Balance = Balance + " + amount
         + " WHERE Account_Number = " + accountNumber);      
      stat.close();
      conn.close();
   }

   /**
      Withdraws money from a bank account.
      @param accountNumber the account number
      @param amount the amount to withdraw
   */
   public void withdraw(double amount)
      throws SQLException
   {
      Connection conn = SimpleDataSource.getConnection();
      Statement stat = conn.createStatement();
      stat.execute("UPDATE Account"
         + " SET Balance = Balance - " + amount
         + " WHERE Account_Number = " + accountNumber);      
      stat.close();
      conn.close();
   }

   /**
      Gets the balance of a bank account.
      @param accountNumber the account number
      @return the account balance
   */
   public double getBalance()
      throws SQLException
   {
      double balance = 0;
      Connection conn = SimpleDataSource.getConnection();
      Statement stat = conn.createStatement();
      ResultSet result = stat.executeQuery("SELECT Balance"
         + " FROM Account WHERE Account_Number = "
         + accountNumber);
      if (result.next())
         balance = result.getDouble(1);
      result.close();
      stat.close();
      conn.close();
      return balance;
   }

   private int accountNumber;
}

