import java.text.DateFormat;
import java.util.Date;

/**
   This bean formats the time of day from a given date.
*/
public class TimeFormatterBean
{
   /**
      Initializes the formatter.
   */
   public TimeFormatterBean()
   {
      timeFormatter = DateFormat.getTimeInstance();
   }

   /**
      Write-only date property. 
      @param aDate the date to be formatted.
   */
   public void setDate(Date aDate)
   {
      theDate = aDate;
   }

   /**
      Read-only time property.
      @return the formatted time
   */
   public String getTime()
   {
      String timeString = timeFormatter.format(theDate);
      return timeString;
   }

   private DateFormat timeFormatter;
   private Date theDate;
}
